# This is the MSC 4.0 and higher OS/2 configuration file for DMAKE
#	It simply modifies the values of SRC, and checks to see if
#	OSENVIRONMENT is defined.  If so it includes the appropriate
#	config.mk file.
#
# It also sets the values of .SOURCE.c and .SOURCE.h to include the local
# directory.
#
STARTUPFILE	= $(OS)\startup.mk
CPPFLAGS 	= $(CFLAGS)
LDOBJS		= $(CSTARTUP) $(OBJDIR)/{$(<:f)}
LDARGS		= $(LDFLAGS) -o $@ $(LDOBJS) $(LDLIBS)

# Definition of macros for library, and C startup code.

# Debug flags
DB_CFLAGS	= -g -DDBUG
DB_LDFLAGS	= -g
DB_LDLIBS	=

# NO Debug flags
NDB_CFLAGS	= -Zmtd -O
NDB_LDFLAGS	= -Zmtd
NDB_LDLIBS	=

# Local configuration modifications for CFLAGS
# -- undef __GNUC__: fake dmake.c to use the ANSI varargs code --
CC = gcc
CFLAGS += -I$(OS) -DOS2 -U__GNUC__

# Sources that must be defined for each different version
OSSRC := arlib.c dirbrk.c rmprq.c ruletab.c runargv.c dcache.c
SRC  += $(OSSRC)
.SETDIR=$(OS) : $(OSSRC)

# Set source dirs so that we can find files named in this
# config file.
.SOURCE.h : $(OS)

# See if we modify anything in the lower levels.
.IF $(OSENVIRONMENT) != $(NULL)
   .INCLUDE .IGNORE : $(osrdir)$(DIRSEPSTR)$(OSENVIRONMENT)$(DIRSEPSTR)config.mk
.END
